/*
 * This file was automatically generated by EvoSuite
 * Thu Jun 23 13:14:35 GMT 2022
 */

package ir.ramtung.impl2;

import ir.ramtung.sts01.LibraryException;
import org.junit.Test;

import static org.evosuite.runtime.EvoAssertions.verifyException;
import static org.junit.Assert.*;
import static org.evosuite.runtime.EvoAssertions.*;
import ir.ramtung.impl2.Book;
import ir.ramtung.impl2.Document;
import ir.ramtung.impl2.Magazine;
import ir.ramtung.impl2.Prof;
import ir.ramtung.impl2.Reference;
import ir.ramtung.impl2.Student;
import java.util.LinkedList;
import java.util.List;
import org.evosuite.runtime.EvoRunner;
import org.evosuite.runtime.EvoRunnerParameters;
import org.junit.runner.RunWith;

@RunWith(EvoRunner.class) @EvoRunnerParameters(mockJVMNonDeterminism = true, useVFS = true, useVNET = true, resetStaticState = true, separateClassLoader = true, useJEE = true) 
public class Person_ESTest extends Person_ESTest_scaffolding {

  @Test(timeout = 4000)
  public void test00()  throws Throwable  {
      Prof prof0 = new Prof("[=2N+!");
      Book book0 = new Book("4_&EwRgw`9e}@(", (-3187));
      prof0.borrow(book0);
      Reference reference0 = new Reference("4_&EwRgw`9e}@(", (-756));
      reference0.day = (-1);
      prof0.borrow(reference0);
      prof0.timePass();
      assertEquals(5000, prof0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test01()  throws Throwable  {
      Student student0 = new Student("0MF7xZTB,UUTm", "0MF7xZTB,UUTm");
      Magazine magazine0 = new Magazine("", 1, 1, 0);
      student0.borrow(magazine0);
      student0.timePass();
      student0.timePass();
      assertEquals(0, student0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test02()  throws Throwable  {
      Prof prof0 = new Prof("RQKv&?F");
      Reference reference0 = new Reference("RQKv&?F", 1390);
      prof0.penalty = 2998;
      prof0.borrow(reference0);
      prof0.returnDoc("RQKv&?F");
      assertEquals("RQKv&?F", prof0.getName());
  }

  @Test(timeout = 4000)
  public void test03()  throws Throwable  {
      Prof prof0 = new Prof("");
      Reference reference0 = new Reference("", 1);
      prof0.borrow(reference0);
      prof0.borrow(reference0);
      prof0.returnDoc("5w8`0^f'%VwDOU4=SO");
      assertEquals(0, prof0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test04()  throws Throwable  {
      Prof prof0 = new Prof("");
      Reference reference0 = new Reference("", 1);
      prof0.borrow(reference0);
      prof0.borrow(reference0);
      prof0.extend("");
      assertEquals(0, prof0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test05()  throws Throwable  {
      Student student0 = new Student("0MF7xZTB,UUTm", "0MF7xZTB,UUTm");
      student0.penalty = 21;
      int int0 = student0.getPenalty();
      assertEquals(21, int0);
  }

  @Test(timeout = 4000)
  public void test06()  throws Throwable  {
      Student student0 = new Student((String) null, (String) null);
      student0.penalty = (-777);
      int int0 = student0.getPenalty();
      assertEquals((-777), int0);
  }

  @Test(timeout = 4000)
  public void test07()  throws Throwable  {
      Student student0 = new Student((String) null, (String) null);
      student0.getName();
      assertEquals(0, student0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test08()  throws Throwable  {
      Prof prof0 = new Prof("");
      String string0 = prof0.getName();
      assertEquals(0, prof0.getPenalty());
      assertNotNull(string0);
  }

  @Test(timeout = 4000)
  public void test09()  throws Throwable  {
      Prof prof0 = new Prof("");
      prof0.canBorrow();
      assertEquals(0, prof0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test10()  throws Throwable  {
      Student student0 = new Student("'a^]}#{#4~sZ9z{C", "'a^]}#{#4~sZ9z{C");
      LinkedList<Document> linkedList0 = new LinkedList<Document>();
      Book book0 = new Book("'a^]}#{#4~sZ9z{C", (-472));
      linkedList0.add((Document) book0);
      student0.docsBorrow = (List<Document>) linkedList0;
      Reference reference0 = new Reference((String) null, 0);
      linkedList0.add((Document) reference0);
      student0.canBorrow();
      assertEquals(0, student0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test11()  throws Throwable  {
      Prof prof0 = new Prof("U_G1U{,val R");
      prof0.dayBorrow = null;
      // Undeclared exception!
      try { 
        prof0.timePass();
        fail("Expecting exception: NullPointerException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // no message in exception (getMessage() returned null)
         //
         verifyException("ir.ramtung.impl2.Person", e);
      }
  }

  @Test(timeout = 4000)
  public void test12()  throws Throwable  {
      Prof prof0 = new Prof("eVfkpbLbx[)_");
      LinkedList<Integer> linkedList0 = new LinkedList<Integer>();
      prof0.dayBorrow = (List<Integer>) linkedList0;
      Integer integer0 = new Integer(0);
      linkedList0.add(integer0);
      // Undeclared exception!
      try { 
        prof0.timePass();
        fail("Expecting exception: IndexOutOfBoundsException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // Index: 0, Size: 0
         //
         verifyException("java.util.ArrayList", e);
      }
  }

  @Test(timeout = 4000)
  public void test13()  throws Throwable  {
      Prof prof0 = new Prof((String) null);
      Magazine magazine0 = new Magazine((String) null, 0, 0, 0);
      prof0.borrow(magazine0);
      // Undeclared exception!
      try { 
        prof0.returnDoc("Ez=IB12?+");
        fail("Expecting exception: NullPointerException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
//          verifyException("ir.ramtung.impl2.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test14()  throws Throwable  {
      Student student0 = new Student("wqc5`wNN*+yyY/+", "WR*f");
      LinkedList<Document> linkedList0 = new LinkedList<Document>();
      student0.docsBorrow = (List<Document>) linkedList0;
      Reference reference0 = new Reference("", 0);
      linkedList0.add((Document) reference0);
      reference0.title = null;
      // Undeclared exception!
      try { 
        student0.extend("");
        fail("Expecting exception: NullPointerException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
//          verifyException("ir.ramtung.impl2.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test15()  throws Throwable  {
      Prof prof0 = new Prof("RqqsdV[`n");
      LinkedList<Boolean> linkedList0 = new LinkedList<Boolean>();
      prof0.canExtend = (List<Boolean>) linkedList0;
      Book book0 = new Book(">-_Wc2$J7+:j", 0);
      prof0.borrow(book0);
      LinkedList<Boolean> linkedList1 = new LinkedList<Boolean>();
      prof0.canExtend = (List<Boolean>) linkedList1;
      // Undeclared exception!
      try { 
        prof0.extend(">-_Wc2$J7+:j");
        fail("Expecting exception: IndexOutOfBoundsException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // Index: 0, Size: 0
         //
         verifyException("java.util.LinkedList", e);
      }
  }

  @Test(timeout = 4000)
  public void test16()  throws Throwable  {
      Prof prof0 = new Prof((String) null);
      prof0.docsBorrow = null;
      // Undeclared exception!
      try { 
        prof0.canBorrow();
        fail("Expecting exception: NullPointerException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // no message in exception (getMessage() returned null)
         //
         verifyException("ir.ramtung.impl2.Prof", e);
      }
  }

  @Test(timeout = 4000)
  public void test17()  throws Throwable  {
      Student student0 = new Student("", "");
      // Undeclared exception!
      try { 
        student0.borrow((Document) null);
        fail("Expecting exception: NullPointerException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // no message in exception (getMessage() returned null)
         //
         verifyException("ir.ramtung.impl2.Person", e);
      }
  }

  @Test(timeout = 4000)
  public void test18()  throws Throwable  {
      Prof prof0 = new Prof("");
      LinkedList<Document> linkedList0 = new LinkedList<Document>();
      prof0.docsBorrow = (List<Document>) linkedList0;
      Magazine magazine0 = new Magazine("", 0, 0, 1751);
      linkedList0.add((Document) magazine0);
      // Undeclared exception!
      try { 
        prof0.returnDoc("");
        fail("Expecting exception: IndexOutOfBoundsException");
      
      } catch(Throwable e) {
//          if (!(e instanceof LibraryException)) {
//              fail("Unexpected exception");
//          }
         //
         // Index: 0, Size: 0
         //

         verifyException("java.util.ArrayList", e);
      }
  }

  @Test(timeout = 4000)
  public void test19()  throws Throwable  {
      Prof prof0 = new Prof("SC=:50g!@VZz79ED{|");
      Magazine magazine0 = new Magazine("SC=:50g!@VZz79ED{|", 101, 101, 101);
      prof0.borrow(magazine0);
      prof0.extend("SC=:50g!@VZz79ED{|");
      try { 
        prof0.extend("SC=:50g!@VZz79ED{|");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // cant extend
         //
         verifyException("ir.ramtung.impl2.Person", e);
      }
  }

  @Test(timeout = 4000)
  public void test20()  throws Throwable  {
      Prof prof0 = new Prof("h3QhBIjT:jW[7Y");
      Magazine magazine0 = new Magazine("h3QhBIjT:jW[7Y", 0, (-197), 335);
      prof0.borrow(magazine0);
      try { 
        prof0.extend("Q&39m%E3TwyD3");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // cant extend
         //
         verifyException("ir.ramtung.impl2.Person", e);
      }
  }

  @Test(timeout = 4000)
  public void test21()  throws Throwable  {
      Prof prof0 = new Prof("-j!.T/ ");
      String string0 = prof0.getName();
      assertNotNull(string0);
      assertEquals(0, prof0.getPenalty());
  }

  @Test(timeout = 4000)
  public void test22()  throws Throwable  {
      Prof prof0 = new Prof("RqqsdV[`n");
      int int0 = prof0.getPenalty();
      assertEquals(0, int0);
  }
}
